import { ChangeDetectorRef, ElementRef, Input, Injectable, SimpleChanges, ViewChild } from '@angular/core';
import * as _ from 'lodash-es';
import { ComponentHoodClass } from './component-hood.class';
import { PrismInterface } from './prism.interface';
import { CallbackType } from './prism.type';
import { PrismService } from './prism.service';
export class PrismHoodClass extends ComponentHoodClass {
    constructor(changeDetectorRef, prismService) {
        super();
        this.changeDetectorRef = changeDetectorRef;
        this.prismService = prismService;
    }
    set hooks(value) {
        this._hooks = value;
        if (value instanceof Object) {
            _.forEach(value, (element, key) => {
                this.prismService.hooks().add(key, element);
            });
        }
    }
    get hooks() {
        return this._hooks;
    }
    set language(value) {
        if (value) {
            if (typeof (value) === 'string') {
                this._language = value;
            }
            else {
                throw new Error(`Property \`language\` should be \`string\` instead of provided \`${typeof (value)}\``);
            }
        }
        else {
            throw new Error('Missing property `language`.');
        }
    }
    ;
    get language() {
        return this._language;
    }
    highlightElement(change = false) {
        if (this.change === change) {
            this.prismService.highlight(this.el, {
                async: this.async,
                callback: this.callback,
                code: this.code,
                interpolation: this.interpolation
            });
            this.change = false;
        }
    }
}
//# sourceMappingURL=prism.class.js.map